
################################################################################
# 
#                    NEC CORPORATION PROPRIETARY INFORMATION
#        This software is supplied under the terms of a license agreement or
#        nondisclosure agreement with NEC Corporation and may not be copied
#        or disclosed except in accordance with the terms of that agreement.
#          Copyright (c) 2015 NEC Corporation. All Rights Reserved.
# 
################################################################################

package BmcConfig;

use CommonModule;

sub new {
	my $class = shift;
	my $self = {@_} ;
	
	if ( !defined($self->{host}) )
	{
		print "'host' is required.\n";
		return;
	}
	if ( !defined($self->{username}) )
	{
		print "'username' is required.\n";
		return;
	}
	if ( !defined($self->{password}) )
	{
		print "'password' is required.\n";
		return;
	}
	if ( !defined($self->{ssl}) )
	{
		$self->{ssl}=0;
	}
	if ( !defined($self->{skipcertcheck}) )
	{
		$self->{skipcertcheck}=0;
	}
	if ( !defined($self->{certfile}) )
	{
		$self->{certfile}='';
	}
	
	if ($self->{ssl})
	{
		# HTTPS
		$self->{url} = "https://" . $self->{host};
	}
	else
	{
		# HTTP
		$self->{url} = "http://" . $self->{host};
	}
	
	bless $self, $class;
	
	return $self;
}

sub getConfig {
	my $self = shift;
	my $type;
	my $filename;
	my $json;
	my $res;
	my $checkcert = !($self->{skipcertcheck});
	
	($type, $filename) = @_;
	
    $bmc = CommonModule->new( host   => $self->{host},
                       username      => $self->{username} ,
                       password      => $self->{password} ,
                       ssl           => $self->{ssl},
                       skipcertcheck => $self->{skipcertcheck},
                       certfile      => $self->{certfile} );
	
	( $res , $json ) = $bmc->getConfig($type, $filename);
	
	return ( $res , $json );
}

sub setConfig {
	my $self = shift;
	my $url;
	my $type;
	my $filename;
	my $res;
	my $checkcert = !($self->{skipcertcheck});
	
	($type , $filename) = @_;
	
	if ( !defined($filename) )
	{
		print "'filename' is required.\n";
		return -1;
	}
	
	if (!-f $filename)
	{
		print "'$filename' is not found.\n";
		return -1;
	}
	
    $bmc = CommonModule->new( host   => $self->{host},
                       username      => $self->{username} ,
                       password      => $self->{password} ,
                       ssl           => $self->{ssl},
                       skipcertcheck => $self->{skipcertcheck},
                       certfile      => $self->{certfile} );
	
	( $res ) = $bmc->setConfig($type, $filename);
	
	return $res;
}

1;

