#!/usr/local/bin/perl

################################################################################
# 
#                    NEC CORPORATION PROPRIETARY INFORMATION
#        This software is supplied under the terms of a license agreement or
#        nondisclosure agreement with NEC Corporation and may not be copied
#        or disclosed except in accordance with the terms of that agreement.
#          Copyright (c) 2015 NEC Corporation. All Rights Reserved.
# 
################################################################################

use ServerProfile;
use JSON;

my $data;
my $json;
my $ret;
my $delaytime;
my $filename = 'tmp.json';

# 接続設定
# 接続先：172.16.200.2
# ユーザ：Administrator
# パスワード：Administrator
# SSL接続：有効
# SSL証明書チェック：無効
# 証明書チェック用認証局設定：無効
$server = ServerProfile->new( host   => '172.16.200.2',
                       username      => 'Administrator' ,
                       password      => 'Administrator' ,
                       ssl           => 1 ,
                       skipcertcheck => 1 ,
                       certfile      => '' );

# 設定を取得（ファイル書き出し省略）
( $ret , $json ) = $server->getBmcProfile('basic');

if ($ret != 0){
	print "Failed to get json. ( $ret )\n";
	$ret = -$ret;
	exit $ret;
}

# JSONをデコード
$data = JSON->new->decode($json);

# DELAYTIMEを取得
$delaytime = $data->{BASICCONFIG}->{POWEROPTION}->{DELAYTIME};

# DELAYTIMEをインクリメント
print "DELAYTIME : $delaytime";
$delaytime++;
print " -> $delaytime\n";

# DELAYTIMEをセット
# （DELAYTIMEは数値なので、0を足し算して確実に数値扱いさせる）
$data->{BASICCONFIG}->{POWEROPTION}->{DELAYTIME} = 0 + $delaytime;

# JSONにエンコード
$json = JSON->new->encode($data);

# JSONをファイルに書き出し
open (OUT, "> $filename");
print OUT $json;
close (OUT);

# BMCに設定
$ret = $server->setBmcProfile('basic' , $filename );

if ($ret != 0){
	print "Failed to set json. ( $ret )\n";
	exit;
	$ret = -$ret;
	exit $ret;
}

exit;

